#include <iostream>
#include <cstdio>
#include <cmath>
#include <algorithm>
#include <set>
#include <map>
#include <queue>
#include <cstdlib>
#include <string>
#include <string.h>
#include <vector>
#include <ctime>
#include <cassert>

using namespace std;

#define ll long long
#define ld long double
#define mp make_pair
#define pb push_back
#define y0 askjdfghjksdf
#define y1 askldjfahsd
#define fst first
#define snd second

template<typename T> T abs(T x) {if (x>=0) return x; return -x;}



const ll mod = 2017;

ll bpow(ll x, ll n)
{
	ll res = 1;
	while (n)
	{
		if (n & 1)
			res = (res * x) % mod;
		x = (x * x) % mod;
		n >>= 1;
	}
	return res;
}

ll c(ll n, ll k)
{
	ll res = 1;

	for (int i = 0; i < k; i++)
	{
		res = (res * (n - i)) % mod;
		res = res * bpow(i + 1, mod - 2);
		res %= mod;
	}
	return res;
}


struct m
{
	ll a[11][11];
	m operator * (m b)
	{
		m res;
		for (int i = 0; i < 11; i++)
		{
			for (int j = 0; j < 11; j++)
			{
				res.a[i][j] = 0;
				for (int k = 0; k < 11; k++)
					res.a[i][j] += a[i][k] * b.a[k][j];
				res.a[i][j] %= mod;
			}
		}
		return res;
	}
};

int main()
{
//	freopen("a.in", "r", stdin);
	int t;
	cin >> t;
	while (t--)
	{
		ll n, k;
		cin >> n >> k;

		m res;
		for (int i = 0; i < 11; i++)
			for (int j = 0; j < 11; j++)
				res.a[i][j] = i == j;
		m x;

		for (int i = 0; i < 11; i++)
			for (int j = 0; j < 11; j++)
				x.a[i][j] = 0;

		for (int i = 0; i < 11; i++)
		{


			x.a[i][i] = i + 1;
			if (i)
				x.a[i][i - 1] = 1;
		}

		
		n--;

		while (n)
		{
			if (n & 1)
				res = res * x;
			x = x * x;
			n >>= 1;
		}

		cout << res.a[k - 1][0] % mod << endl;
	}

	return 0;
}