#include <iostream>
#include <cstdlib>
#include <cstdio>
#include <cmath>
#include <algorithm>
#include <ctime>
#include <vector>
#include <string>
#include <ctime>

#define next(x) (x + ((x) & (-x)))
#define prev(x) (x - ((x) & (-x)))
#define N 2002
#define md 1000000007
#define sqr(x) ((x) * (x))
#define INF (1 << 30)
#define mp make_pair
#define ll long long

using namespace std;

pair <long, long> fib(long f1, long f2, long n)
{
	while (f2 + f1< n)
	{
		f2 += f1;
		f1 = f2 - f1;
	}
	return mp(f1, f2);
}

pair <int, int> axby(ll a, ll b)
{
	if (!b) return mp(1, 0);
	ll x1 = 0, y1 = 1, x2 = 1, y2 = 0, x, y;
	while (b > 0)
	{
		ll q = a / b;
		ll r = a - q * b;
		x = x2 - q * x1;
		y = y2 - q * y1;
		a = b;
		b = r;
		x2 = x1;
		x1 = x;
		y2 = y1;
		y1 = y;
	}
	return mp(x2, y2);
}

void kostyl(int n)
{
	switch (n)
	{
	case 2:
	case 3:
	case 5:
	case 8: {cout << "1 1" << endl; return; }
	case 4:
	case 6: {cout << "2 2" << endl; return; }
	case 7: {cout << "1 3" << endl; return; }
	case 9: {cout << "3 3" << endl; return; }
			//case 11:{cout << "1 3" << endl; return; }
	}
}

vector <int> tester;

void gen()
{
	freopen("input.txt", "w", stdout);
	cout << 100 << endl; int t = 1000000000;
	for (int i = 0; i < 100; ++i)
	{
		cout << t-- << endl;
	}
}

bool check()
{
	freopen("output.txt", "r", stdin);
	int f1, f2, g = 1000000000;
	for (int t = 0; t < 100; t++)
	{
		cin >> f1 >> f2;
		while (f1 + f2 < g)
		{
			f2 += f1;
			f1 = f2 - f1;
		}
		if (f1 + f2 != g) return false;
	}
	return true;
}

int f[1000000];

int main() {
	//gen(); return 0;
	//if (check()) cout << "OK" << endl; system("pause");
	//freopen("input.txt", "r", stdin);
	//freopen("output.txt", "w", stdout);
	int t;
	cin >> t;
	ll f1 = 1, f2 = 1;
	int pos = 3; f[0] = 1;
	f[1] = f[2] = 1;
	while (f2 <= 1000000000)
	{
		f[pos++] = f1 + f2;
		f2 += f1;
		f1 = f2 - f1;
	}
	while (t--)
	{
		int n;
		cin >> n;
		if (n <= 9) { kostyl(n); continue; }
		int k = 2;
		bool flag = false;
		pos = 2;
		ll ansa = 1, ansb = n - 1, cura = 0, curb = 0;
		/*while (f[k] + f[k - 1] <= n) k++; k--;
		for (int i = 2; i < n; i++)
		{
			curb = n / (f[i] + f[i - 1]);
			if (!((n - curb * f[i]) % f[i - 1]))
			{
				cura = (n - curb * f[i]) / f[i - 1];
				if (cura <= curb)
					if (ansb > curb || (ansb == curb && ansa > cura)) { ansb = curb; ansa = cura; break; }
			}
		}
		cout << ansa << " " << ansb << endl;*/
		//while (f[pos] + f[pos + 1] < n) ++pos; pos--;
		if (f[pos] == n) { cout << "1 1\n"; continue; }
		//pos++;
		ll b, a;
		for (b = 1; b <= n; ++b)
		{
			ll t = n / b;
			while (b * f[pos] < n) pos++;
			while (b * f[pos] >= n) --pos; 
			//pos--;
			a = (n - b * f[pos]) / f[pos - 1];
			if (a <= b && a > 0 && !((n - b * f[pos]) % f[pos - 1])) { ansa = a; ansb = b; break; }

		}
		cout << ansa << " " << ansb << endl;
	}
	return 0;
}

