#include <iostream>
#include <cstdio>
#include <string>
#include <cstring>
#include <map>
#include <set>
#include <stack>
#include <queue>
#include <vector>
#include <cmath>
#include <algorithm>
#include <ctime>
#include <cstdlib>
#include <cassert>

using namespace std;
#define forn(i, n) for (int i = 0; i < n; ++i)
#define ALL(a) a.begin(), a.end()
#define X first
#define Y second
#define sz(a) ((int)a.size())
#define L(a) sz(a)
#define pb(a) push_back(a)
#define mp(a, b) make_pair(a, b)
#define ms(a) memset(a,0,sizeof(a))
#define ms1(a) memset(a,-1,sizeof(a))

typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;
typedef pair<int, int> pii;

const double PI = 3.1415926535897932384626433832795;

map<ll, int> mm;

int n;

int calc(ll x) {
	if (x >= n) return 0;
	if (mm.count(x) == 0) {
		for (int i = 2; i <= 9; ++i) {
			ll to = x * i;
			if (!calc(to)) return mm[x] = 1;
		}
		return mm[x] = 0;
	}
	return mm[x];
}

void solve() {
	scanf("%d", &n);
	mm.clear();
	int res = calc(1);
	if (res) printf("1\n");
	else printf("2\n");
}

int main() {
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	//freopen("output.txt", "w", stdout);
#else
	/*freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);*/
#endif
	int T; scanf("%d", &T); while (T--) solve();
	return 0;
}
