#include <cstdio>
#include <iostream>
#include <cmath>
#include <algorithm>
#include <vector>
#include <map>
#include <cstring>
#include <string>
#include <set>
#include <iomanip>
using namespace std;
typedef long long LL;
typedef pair<int,int> PII;
typedef vector<int> VI;
#define fname ""
#define pb push_back
#define F first
#define S second
#define mp make_pair
#define forit(it, s) for(__typeof(s.begin()) it = s.begin(); it != s.end(); it++)
#define all(s) s.begin(),s.end()
const int maxn = (int)1e6;
const int mod = 2017;
const int inf = (1 << 30) - 1;

int n, k, T;
int rev[mod + 1], fact[mod + 1], c[mod + 1];

int binpow(int x, int pw) {
	int res = 1;
	while (pw) {
		if (pw) res = res * x % mod;
		x = x * x % mod;
		pw >>= 1;
	}
	return res;
}


int main()
{


	rev[1] = 1;
	for (int i = 2; i < mod; i++) 
		rev[i] = (mod - (mod / i) * rev[mod % i] % mod) % mod;
	fact[0] = 1;
	for (int i = 1; i <= 15; i++) 
		fact[i] = (fact[i-1] * i) % mod;
	
	scanf("%d", &T);
	while (T--) {
		scanf("%d %d", &n, &k);
		int ans = 0;
	
	    c[0] = 1;
		for (int i = 1; i <= k; i++) {
			c[i] = rev[fact[i]];
			for (int j = k; j >= k - i + 1; j--) 
				c[i] = (c[i] * (j % mod)) % mod;
		}

		for (int i = 0; i < k; i++) 
			ans = (ans + mod + (i & 1 ? -1 : 1) * binpow(k - i, n) * c[i] % mod) % mod;
		ans = ans * rev[fact[k]] % mod;
		printf("%d\n", ans);
	}
	 

	return 0;
}
