#include <set>
#include <map>
#include <queue>
#include <deque>
#include <vector>
#include <cstdio>
#include <cstdlib>
#include <cstring>
#include <iostream>
#include <algorithm>
using namespace std;

#define left first
#define right second
#define pb push_back
#define mp make_pair
#define sz(a) ((int)a.size())
#define all(a) a.begin(), a.end()
#define ms(a, x) memset(a, x, sizeof a)

typedef long long ll;
typedef vector<int> vi;
typedef pair<int,int> pii;
typedef pair<pii, int> tri;

const int N = 1<<17;
const int inf = 1<<30;

void solve() {
	int n; cin >> n;
	bool win = false;	
	while(n > 1) {
		if (win) {
			n = (n + 1) / 2;
		} else {
			n = (n + 8) / 9;
		}
		win = !win;
	}
	if (win) {
		cout << 1 << endl;
	} else {
		cout << 2 << endl;
	}
}

int main() {
	#ifdef LOCAL
	freopen("a.in", "r", stdin);
	freopen("a.out", "w", stdout);
	#endif

	int T; cin >> T;

	while(T--) solve();

	return 0;
}
