#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef long double ld;

#define sz(x) ((int) (x).size())
#define pb push_back
#define mp make_pair
#define fi first
#define se second

#define NAME "b"

char s[100];
char t[100];
char buf[100][100];
int len[100];

ll calc(char *s, int n)
{
	ll res = 0;
	for (int i = 0; i < n; ++i)
	{
		if (s[i] == '1')
			res += (1ll << i);
	}
	return res;
}

char w[1001];

int print(ll a)
{
	if (a == 0)
	{
		w[0] = '0';
		return 1;
	}
	int ans = 0;
	while (a)
	{
		if (a & 1ll)
			w[ans] = '1';
		else
			w[ans] = '0';
		++ans;
		a >>= 1;
	}
	return ans;
}

void solve(int tn)
{
	cout << "Test " << tn << '\n';
	scanf("%s%s", s, t);
	int n = strlen(s);
	int m = strlen(t);
	reverse(s, s + n);
	reverse(t, t + m);
	ll A = calc(s, n);
	ll B = calc(t, m);
	ll C = A * B;
	int k = print(C);
	for (int i = 0; i < n; ++i)
		buf[0][i] = s[i];
	len[0] = n;
	for (int i = 0; i < m; ++i)
		buf[1][i] = t[i];
	len[1] = m;
	len[2] = max(n, m);
	for (int i = 0; i < len[2]; ++i)
		buf[2][i] = '-';
	for (int i = 0; i < m; ++i)
	{
		len[3 + i] = n + i;
		for (int j = 0; j < i; ++j)
			buf[3 + i][j] = ' ';
		for (int j = 0; j < n; ++j)
			buf[3 + i][j + i] = (t[i] == '0' ? '0' : s[j]);
	}
	int max_len = max(k, n + m - 1);
	for (int i = 0; i < max_len; ++i)
		buf[3 + m][i] = '-';
	len[3 + m] = max_len;
	len[4 + m] = k;
	for (int i = 0; i < k; ++i)
		buf[4 + m][i] = w[i];
	for (int i = 0; i < m + 5; ++i)
	{
		for (int j = len[i]; j < max_len; ++j)
			buf[i][j] = ' ';
		len[i] = max_len;
		reverse(buf[i], buf[i] + len[i]);
		while (len[i] > 0 && buf[i][len[i] - 1] == ' ')
			--len[i];
		buf[i][len[i]] = 0;
		cout << buf[i] << '\n';
	}
	
	cout << '\n';
}

int main()
{
	#ifdef LOCAL
	assert(freopen(NAME ".in", "r", stdin));
	#endif // LOCAL
	int tn;
	cin >> tn;
	for (int i = 0; i < tn; ++i)
		solve(i + 1);
	#ifdef LOCAL
	cerr << "Time: " << double(clock()) / CLOCKS_PER_SEC << "\n";
	#endif // LOCAL
	return 0;
}
