#include <cstdio>
#include <cstdlib>
#include <cmath>
#include <iostream>
#include <string>
#include <vector>
#include <memory.h>
#include <algorithm>
#include <map>
#include <set>
#include <queue>

using namespace std;

#define fore(i, b, e) for (int i = (int)b; i <= (int)e; i++)
#define forn(i, n) for (int i = 0; i < (int)n; i++)
#define fi first
#define se second
#define pii pair <int, int>
#define mp make_pair
#define i64 long long
#define li long long
#define vi vector <int>

const int maxn = 1e5 + 5;
const int mod = 1e9;

int dp[maxn * 100 + 100];
int a[maxn];
int b[maxn];

void upd(int & x, int y)
{
	x = (x + y) % mod;
}

int main()
{
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
	int tests;
	scanf("%d", &tests);
	forn(test, tests)
	{
		int N, M, K, S;
		scanf("%d%d", &N, &M);
		scanf("%d", &K);
		forn(j, K)
			scanf("%d", &a[j]);
		sort(a, a + K);
		K = unique(a, a + K) - a;
		scanf("%d", &S);
		forn(j, S)
			scanf("%d", &b[j]);
		sort(b, b + S);
		S = unique(b, b + S) - b;
		
		fore(j, N, M)
			dp[j] = 0;
		dp[N] = 1;
		int answer = 0;
		fore(i, N, M) if (dp[i] != 0)
		{
			forn(j, K)
				upd(dp[a[j] + i], dp[i]);
			forn(j, S)
			{
				if (i * b[j] == M)
					upd(answer, dp[i]);
				else upd(dp[i * b[j]], dp[i]);
			}
		}
		printf("%d\n", answer);
	}
}