#include <iostream>
#include <cstdio>
#include <set>
#include <map>
#include <queue>
#include <vector>
#include <fstream>
#include <sstream>
#include <algorithm>
#include <cassert>
#include <ctime>
#include <cmath>
#include <string>
#include <memory.h>

#define forn(i, n) for(int i = 0; i < (int)(n); ++i)
#define fore(i, a, b) for(int i = (int)(a); i <= (int)(b); ++i) 
#define for1(i, n) for(int i = 1; i <= (int)(n); ++i)
#define ford(i, n) for(int i = (int)(n) - 1; i >= 0; --i)
#define all(x) (x).begin(), (x).end()
#define mp make_pair
#define pb push_back
#define fi first
#define se second

using namespace std;

typedef long double ld;
typedef long long i64;
typedef vector<int> vi;
typedef vector<i64> vi64;
typedef pair<int, int> pii;
typedef unsigned int u32;
typedef vector<pii> vpi;

vi g[100500];

int main() {
	cin.sync_with_stdio();
	cin.tie(0);
	cout.precision(12);
	cout << fixed;
	cerr.precision(12);
	cerr << fixed;
#ifdef HOME
	freopen("input.txt", "r", stdin);
#endif
	int T;
	cin >> T;
	forn(t, T) {
		int n, m;
		cin >> n >> m;
		forn(i, n) g[i].clear();
		forn(e, m) {
			int a, b;
			cin >> a >> b;
			--a; --b;
			g[a].pb(b);
			g[b].pb(a);
		}
		int ans = n;
		forn(st, n) {
			vi d(n, n);
			vi p(n, -1);
			d[st] = 0;
			queue<int> Q;
			Q.push(st);
			while( !Q.empty() ) {
				int v = Q.front(); Q.pop();
				for(int u: g[v]) if( d[u] > d[v] + 1 ) {
					d[u] = d[v] + 1;
					p[u] = v;
					Q.push(u);
				} else if( d[u] < d[v] ) {
					;
				} else {
					int len = d[v] + d[u] + 1;
					ans = min(ans, len);
					break;
				}
			}
		}
		cout << ans << '\n';
	}
	return 0;
}
