#include <iostream>
#include <iomanip>
#include <string>
#include <cmath>
#include <vector>
#include <algorithm>
#include <ctime>
#include <unordered_map>
#include <queue>
#include <stack>
using namespace std;

typedef long long ll;

inline bool havenot0(const vector<int>& x){
	for (int i = 0; i < x.size(); ++i)
		if (x[i] != 0)
			return true;
	return false;
}

inline ll cnt(vector<int>& x){
	ll ans = 0;
	while (havenot0(x)){
		for (int i = 0; i < x.size(); ++i){
			if (x[i] < 10){
				ans += 1;
				x[i] = 0;
			} else if (x[i] < 19){
				ans += 2;
				x[i] = 0;
			}
			else if (x[i] % 10 != 0){
				++ans;
				x[i] -= x[i] % 10;
			}
		}
		if (havenot0(x)){
			++ans;
			for(int i = 0; i < x.size(); ++i)
				x[i] /= 10;
		}
	}
	return ans;
}

inline void solve(){
	int n; cin >> n;
	int ans = 0;
	vector<int> x(n);
	for (int i = 0; i < n; ++i){
		cin >> x[i];
	}
	ans = cnt(x);
	cout << ans << endl;
}

int main(){
	ios_base::sync_with_stdio(false);
	int ttt;
	cin >> ttt;
	for (int i = 0; i < ttt; ++i){
		solve();
	}
	return 0;
}