#include <bits/stdc++.h>
using namespace std;

#ifdef SG
	#include "debug/debug.h"
#else
	#define show(...)
	#define debug(...)
	#define deepen(...)
	#define timer(...)
#endif

#define forn(i,n) for (int i = 0; i < int(n); ++i)
#define ford(i,n) for (int i = int(n) - 1; i >= 0; --i)
#define ve vector
#define pa pair
#define tu tuple
#define mp make_pair
#define mt make_tuple
#define pb push_back
#define fs first
#define sc second
#define all(a) (a).begin(), (a).end()
#define sz(a) ((int)(a).size())

typedef long double ld;
typedef long long ll;
typedef unsigned long long ull;
typedef unsigned int ui;
typedef unsigned char uc;
typedef pa<int, int> pii;
typedef pa<int, ll> pil;
typedef pa<ll, int> pli;
typedef pa<ll, ll> pll;
typedef ve<int> vi;

const ld pi = 3.1415926535897932384626433832795l;

template<typename T> inline auto sqr (T x) -> decltype(x * x) {return x * x;}
template<typename T> inline T abs (T x) {return x > T() ? x : -x;}
template<typename T1, typename T2> inline bool umx (T1& a, T2 b) {if (a < b) {a = b; return 1;} return 0;}
template<typename T1, typename T2> inline bool umn (T1& a, T2 b) {if (b < a) {a = b; return 1;} return 0;}

const int N = 1000000000;

struct Input {
	int n;
	
	bool read () {
		return cin >> n;
	}

	void init (const Input &input) {
		*this = input;
	}
};

struct Data: Input {
	bool ans;
	
	void write () {
		puts(ans ? "1" : "2");
	}
	
	virtual void solve () {}
	
	virtual void clear () {
		*this = Data();
	}
};

struct Solution: Data {
	static const int M = N / 9 + 1;
	bool w[M];
	vi q;
	
	Solution () {
		memset(w, 0, sizeof w);
		q.pb(1);
		forn (i, sz(q)) {
			int t = q[i];
			if (t * 2 < M && !w[t * 2]) {
				q.pb(t * 2);
				w[t * 2] = 1;
			}
			if (t * 3 < M && !w[t * 3]) {
				q.pb(t * 3);
				w[t * 3] = 1;
			}
			if (t * 5 < M && !w[t * 5]) {
				q.pb(t * 5);
				w[t * 5] = 1;
			}
			if (t * 7 < M && !w[t * 7]) {
				q.pb(t * 7);
				w[t * 7] = 1;
			}
		}
		sort(all(q));
		clear();
	}
	
	void solve () {
		ford (i, sz(q)) {
			if (q[i] * 9 >= n) {
				w[q[i]] = 1;
				continue;
			}
			for (int t = 2; t <= 9; ++t) {
				if (q[i] * t < M && !w[q[i] * t]) {
					w[q[i]] = 1;
					break;
				}
			}
		}
		ans = w[1];
	}
	
	void clear () {
		forn (i, sz(q)) {
			w[q[i]] = 0;
		}
	}
};

Solution sol;

int main () {
	cout.setf(ios::showpoint | ios::fixed);
	cout.precision(20);
#ifdef SG
	freopen("g.in", "r", stdin);
//	freopen("output.txt", "w", stdout);
#else
//	freopen("", "r", stdin);
//	freopen("", "w", stdout);
#endif
	int t;
	cin >> t;
	forn (i, t) {
		sol.read();
		sol.solve();
		sol.write();
		sol.clear();
	}
	return 0;
}
