#include <cstdio>
#include <iostream>
#include <vector>
#include <algorithm>
#include <cstring>
#include <string>
#include <cmath>
#include <map>
#include <set>
#include <climits>
#include <cassert>
#include <cctype>
#include <queue>
#include <ctime>
using namespace std;

typedef long long ll;
typedef double dbl;
typedef long double ld;

#define mp make_pair
#define pb push_back
#define sz(x) (int)x.size()
#define all(x) x.begin(),x.end()
#define X first
#define Y second

const ll maxn = 2000*100 + 10;
const dbl eps = 1e-9;
const int mod = 2017;

int ppow(int a, int b) {
	if (b == 0)
		return 1;
	if (b % 2 == 0) {
		int t = ppow(a, b/2);
		return (t * t) % mod;
	}
	else 
		return (ppow(a, b - 1) * a) % mod;
}

int fact [15];

int main() {
#ifdef _MBCS
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif

	/*int t;
	scanf("%d", &t);
	for (int i = 0; i < t; i++) {
		ll n;
		scanf("%lld", &n);
		//printf("%lld: ", n);
		ll cur = 1;
		while (cur < n)
			cur *= 18;
		if (cur != 1)
			cur /= 18;
		int k = (int)ceil((double)n/(double)cur);
		if (1 <= k && k <= 9)
			puts("1");
		else
			puts("2");
	}
	*/
	/*int n;
	scanf("%d", &n);
	for (int qq = 0; qq < n; qq++) {
		string a, b;
		getchar();
		cin >> a >> b;
		printf("Test %d\n", qq + 1);
		vector<string> q;
		for (int j = sz(b) - 1; j >= 0; j--) {
			int cur = b[j] - '0';
			int add = 0;
			string e = "";
			for (int t = sz(a) - 1; t >= 0; t--) {
				int to = a[t] - '0';
				int cur_val = (cur * to + add) % 2;
				add = (cur * to + add) / 2;
				e += (char)(cur_val + '0');
			}
			//reverse(all(e));
			q.pb(e);
		}

		int maxlen = max(sz(a), sz(b));
		for (int i = 0; i < sz(q); i++)
			maxlen = max(maxlen, sz(q[i]) + i);
		vector<string> pp;
		for (int i = 0; i < sz(q); i++) {
			string e  = q[i];
			for (int j = 0; j < i; j++) {
				e += '0';
			}
			//reverse(all(q[i]));
			//reverse(all(e));
			pp.pb(e);
		}

		int add = 0;
		int clen = 0;
		string res = "";
		while (true) {
			int cur = add;
			for (int i = 0; i < sz(pp); i++) {
				if (sz(pp) < clen) {
					cur += pp[i][clen] - '0';
				}
			}
			if (cur == 0) break;
			res += (cur % 2) + '0';
			add = cur / 2;
		}
		maxlen = max(maxlen, sz(res));

		for (int i = 0; i < maxlen - sz(a); i++) printf(" ");
		printf("%s\n", a.c_str());

		for (int i = 0; i < maxlen - sz(b); i++) printf(" ");
		printf("%s\n", b.c_str());

		int kk = max(sz(a), sz(b));
		for (int i = 0; i < maxlen - kk; i++) printf(" ");
		for (int i = 0; i < kk - 1; i++) printf("-");
		printf(" \n");

		for (int i = 0; i < sz(q); i++) {
			for (int j = 0; j < maxlen - sz(q[i]) - i; j++) printf(" ");
			printf("%s", q[i].c_str());
			for (int j = 0; j < i; j++) printf(" ");
			puts("");
		}

		for (int i = 0; i < maxlen - 1; i++) printf("-");
		printf(" \n");
		reverse(all(res));
		printf("%s\n", res.c_str());
	}*/

	fact[1] = 1;
	for (int i = 2; i <= 10; i++)
		fact[i] = (fact[i - 1]*i) % mod;
	int t;
	scanf("%d", &t);
	while (t--) {
		int n, k;
		scanf("%d%d", &n, &k);
		vector <int> dp (k + 1);
		dp[1] = 1;
		int s = 1;
		for (int i = 2; i <= k; i++) {
			int pp = ppow(i, n);
			int f = ppow(fact[i], mod - 2);
			dp[i] = ((pp * f) % mod - s + mod) % mod;
			s = (s + dp[i]) % mod;
		}
		printf("%d\n", dp[k]);
	}

	return 0;
}