#include <algorithm>
#include <cassert>
#include <cmath>
#include <complex>
#include <cstdio>
#include <cstring>
#include <iostream>
#include <map>
#include <set>
#include <string>
#include <sstream>
#include <vector>
using namespace std;

typedef pair<int, int> ii;
typedef vector<int> vi;
typedef vector<ii> vii;
typedef vector<vector<int> > vvi;
typedef long long ll;
template <class T> int size(const T& x) {return x.size();}

const double EPS = 1e-9;
const int INF = 2147483647;

int main() {

    int ts;
    scanf("%d\n", &ts);

    set<long long> p18;
    long long x = 18;
    while (x <= 10000000000LL) {
        p18.insert(x);
        x *= 18;
    }

    for (int t = 0; t < ts; t++) {
        int n;
        scanf("%d\n", &n);

        if (n < 9) {
            cout << 1 << endl;
            continue;
        }

        bool ok = false;
        for (int i = 0; ; i++) {
            long long mn = n / (9 * static_cast<ll>(pow(18, i)));
            long long mx = n / static_cast<ll>(pow(18, i));
            if (mx < 1) {
                break;
            }

            if (mn <= 1 && 1 < mx) {
                ok = true;
                break;
            }
        }

        if (ok) {
            cout << 2 << endl;
        } else {
            cout << 1 << endl;
        }

        /*
        if (n <= 9) {
            cout << 1 << endl;
            continue;
        }
        if (p18.find(n) != p18.end()) {
            cout << 2 << endl;
            continue;
        }

        if (n / (9.0 * pow(18, floor(log(n) / log(18.0)))) < 1)  {
            cout << 1 << endl;
        }else {
            cout << 2 << endl;
        }
        */
    }

    return 0;
}
