#include <stdio.h>
#include <string.h>
#include <math.h>

#include <algorithm>
#include <string>
#include <map>
#include <unordered_map>
#include <set>
#include <vector>
#include <queue>
#include <deque>
#include <iostream>

using namespace std;

int t, n, K, T[100100];

inline bool Bun(long long timp)
{
    long long nr = 0;
    int i;
    for(i = 1; i <= n; ++i)
        nr += (timp / T[i]);
    if(nr >= 1LL * K)
        return true;
    return false;
}

inline long long CautareBinara()
{
    long long st, dr, mij, rez;
    st = 0;
    dr = 2000000000000000000LL;
    rez = dr;
    while(st <= dr)
    {
        mij = (st + dr) / 2;
        if(Bun(mij))
        {
            rez = mij;
            dr = mij - 1;
        }
        else
            st = mij + 1;
    }
    return rez;
}

int main ()
{
#ifdef local
    freopen ("f.in", "r", stdin);
    freopen ("", "w", stdout);
#endif
    int i;
    long long sol;
    cin >> t;
    while (t --)
    {
        cin >> n >> K;
        for(i = 1; i <= n; ++i)
            cin >> T[i];
        sol = CautareBinara();
        cout << sol << "\n";
    }
    return 0;
}
