#include <iostream>
#include <cstdio>
#include <cassert>
#include <vector>
#include <algorithm>
#include <memory.h>

using namespace std;

const int maxn = 1 << 17;
const int maxm = 16;
const int mod = 1e9;

int T;
int n, m, s, k;
int a[maxn], b[maxn];
int dp[maxn];

int main() {
	freopen("input.txt", "r", stdin);

	cin >> T;
	while (T--) {
		cin >> n >> m >> k;
		for (int i = 0; i < k; i++) cin >> a[i];
		sort(a, a + k);
		k = unique(a, a + k) - a;

		cin >> s;
		for (int i = 0; i < s; i++) cin >> b[i];
		sort(b, b + s);
		s = unique(b, b + s) - b;

		for (int i = 0; i <= m; i++) dp[i] = 0;
		dp[n] = 1;
		for (int i = n; i < m; i++) {
			for (int j = 0; j < k && i + a[j] <= m; j++) {
				dp[i + a[j]] = (dp[i + a[j]] + dp[i]) % mod;
			}
			for (int j = 0; j < s && 1LL * i * b[j] <= m; j++) {
				dp[i * b[j]] = (dp[i * b[j]] + dp[i]) % mod;
			}
		}
		int ans = 0;
		for (int i = 0; i < s; i++) {
			if (m % b[i] == 0) {
				ans = (ans + dp[m / b[i]]) % mod;
			}
		}
		cout << ans << endl;
	}

	return 0;
}