#include <iostream>
#include <fstream>
#include <cmath>
#include <cstdio>
#include <cstdlib>
#include <cstring>
#include <string>
#include <vector>
#include <set>
#include <map>
#include <iomanip>
#include <algorithm>
#include <queue>

#define NODES (1 << 17)
#define MAX_N 100000

typedef long long ll;
typedef long double ld;


using namespace std;

int value[NODES<<2];


int n;
int pos[MAX_N];

void add(int pos) {
	int v = 0;
	int begin = 1, end = NODES;
	while (true) {
		//cout << pos << ": " << begin << "; " << end << endl;
		int flast = (begin+end)/2;
		if (pos == end) {
			value[v]++;
			//cout << "++" << begin << ' ' << end << endl;
			return;
		}
		else if (pos <= flast) {
			v = 2 * v + 1;
			end = flast;
		}
		else {//pos > flast
			value[2*v+1]++;
			//cout << "++" << begin << ' ' << end << endl;
			v = 2 * v + 2;
			begin = flast+1;
		}
	}

}

int get(int pos) {
	int v = 0;
	int begin = 1, end = NODES;
	int ans = 0;
	while (begin != end) {
		ans += value[v];
		//if (value[v])
			//cout << "=" << value[v] << endl;
		int flast = (begin+end)/2;
		if (pos <= flast) {
			v = 2 * v + 1;
			end = flast;
		}
		else {//pos > flast
			v = 2 * v + 2;
			begin = flast+1;
		}
	}
	//cout << begin << endl;
	//cout << "v=" << v << endl;
	ans += value[v];
	//cout << "=" << value[v] << endl;
	return ans;
}

int a[MAX_N];

int main() {
	//freopen("input.txt", "r", stdin);
	//freopen("output.txt", "w", stdout);
	//cout << NODES << endl;

	int t;
	cin >> t;
	for (int test = 0; test < t; ++test) {
		cin >> n;
		for (int i = 0; i < n; ++i) {
			int a;
			cin >> a;
			pos[a-1] = i;
		}
	}
	//add(1);
	//add(2);
	//cout << "NODES=" << NODES << endl;
	//cout << get(MAX_N) << endl;
	//cout << get(1) << endl;
	//return 0;

	for (int i = 0; i < n; ++i) {
		//cout << pos[i] << endl;
		a[pos[i]] = get(pos[i]+1);
		add(pos[i]+1);
	}

	for (int i = 0; i < n; ++i) {
		if (i)
			cout << ' ';
		cout << a[i];
	}
	cout << endl;

	return 0;
}
