#include <iostream>
#include <cmath>
#include <string>
#include <algorithm>
#include <cstring>
#include <cstdio>
#include <fstream>
#include <cassert>
#include <map>
#include <set>
#include <vector>
#include <queue>
#include <stack>
#include <functional>
#include <numeric>
#include <ctime>
#include <cstdlib>
#include <sstream>

using namespace std;

#define f first
#define s second
#define mp make_pair
#define pb push_back
#define pii pair<int, int>
#define pll pair<long long, long long>
#define y1 stupid_y1
#define ll long long
#define vi vector<int>
#define forit(it, s) for(__typeof(s.begin()) it = s.begin(); it != s.end(); it++)
#define all(a) a.begin(), a.end()
#define sqr(x) ((x)*(x))
#define sz(a) (int)a.size()
#define file "a"

const int maxn = (int)1e5+11;
const int inf = int(1e9);
const int mod = inf + 7;
const double eps = 1e-9;
const double pi = acos(-1.0);

int n, m;
int a[maxn], b[maxn];
bool used[222];
int mini;
vector < int > g[222];
int d[222];

void bfs(int ind){
	memset(used, 0, sizeof(used));
	for(int i = 0; i <= n; i++) d[i] = inf;
	queue < int > q;
	d[a[ind]] = 0;
	q.push(a[ind]);
	used[a[ind]] = true;


	while(!q.empty() ){
		int v = q.front(); q.pop();
		forit(it, g[v]){
			int to = *it;
			if ( v == a[ind] && to == b[ind] ) continue;
			if ( !used[to] ){
				d[to] = d[v] + 1;
				q.push(to);
				used[to] = true;	
		   	}
		}
	}
	mini = min(d[b[ind]], mini);
}

void solve(){
	scanf("%d%d", &n, &m);

	for(int i = 1; i <= n; i++) g[i].clear();

	for (int i=0;i<m;i++){
		scanf("%d%d", &a[i], &b[i]);
		g[a[i]].pb(b[i]);
		g[b[i]].pb(a[i]);
	}

	mini = inf;
	for (int i=0;i<m;i++){
		bfs(i);
	}

	cout <<mini+1<<endl;

}

int main () {

	#ifdef LOCAL
	freopen(file".in", "r", stdin);
	freopen(file".out", "w", stdout);
	#endif

	int t;
	scanf("%d", &t);

	for (int i=0;i<t;i++){
		solve();
	}

	#ifdef LOCAL
	cerr << (double)clock() * 1.0 / CLOCKS_PER_SEC << endl;
	#endif

	return 0;
}
