#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef long double ld;

#define sz(x) ((int) (x).size())
#define pb push_back
#define mp make_pair
#define fi first
#define se second

#define NAME "f"

const int maxn = 220, maxm = 1100;
int dist[maxn], a[maxm], b[maxm];
vector<int> g[maxn];
int n, m;

int bfs(int s, int t)
{
	queue<int> q;
	fill(dist, dist + n, -1);
	q.push(s);
	dist[s] = 0;
	while (q.size() > 0)
	{
		int v = q.front(); q.pop();
		for (int to : g[v])
			if (dist[to] == -1)
			{
				dist[to] = dist[v] + 1;
				q.push(to);
			}
	}
	return dist[t] == -1 ? n + 5 : dist[t];
}

void solve()
{
	scanf("%d%d", &n, &m);
	for (int i = 0; i < m; ++i)
	{
		scanf("%d%d", &a[i], &b[i]);
		a[i]--; b[i]--;
	}
	int ans = n + 100;
	for (int i = 0; i < m; ++i)
	{
		for (int j = 0; j < n; ++j)
			g[j].clear();
		for (int j = 0; j < m; ++j)
			if (i != j)
				g[a[j]].pb(b[j]),
				g[b[j]].pb(a[j]);
		ans = min(ans, bfs(a[i], b[i]) + 1);
	}
	cout << ans << '\n';
}

int main()
{
	#ifdef LOCAL
	assert(freopen(NAME ".in", "r", stdin));
	#endif // LOCAL
	int tn;
	cin >> tn;
	for (int i = 0; i < tn; ++i)
		solve();
	#ifdef LOCAL
	cerr << "Time: " << double(clock()) / CLOCKS_PER_SEC << "\n";
	#endif // LOCAL
	return 0;
}
