#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef long double ld;

#define sz(x) ((int) (x).size())
#define pb push_back
#define mp make_pair
#define fi first
#define se second

#define NAME "j"

const int maxn = 10;

int field[maxn];
int cnt = 0;
int ans = 0;
int n, m;

bool canHor(int x, int y)
{
	if (y <= 0 || y + 4 > m) return false;
	if (x <= 0 || x + 3 > n) return false;
	return ((field[x - 1] >> (y - 1)) & 31) == 0 && 
		   ((field[x] >> (y - 1)) & 31) == 0 &&
		   ((field[x + 1] >> (y - 1)) & 31) == 0 &&
		   ((field[x + 2] >> (y - 1)) & 31) == 0; 
}

bool canVert(int x, int y)
{
	if (y <= 0 || y + 3 > m) return false;
	if (x <= 0 || x + 4 > n) return false;
	return ((field[x - 1] >> (y - 1)) & 15) == 0 && 
		   ((field[x] >> (y - 1)) & 15) == 0 &&
		   ((field[x + 1] >> (y - 1)) & 15) == 0 &&
		   ((field[x + 2] >> (y - 1)) & 15) == 0 &&
		   ((field[x + 3] >> (y - 1)) & 15) == 0; 
}

void putHor(int x, int y)
{
	field[x] ^= 7 << y;
	field[x + 1] ^= 7 << y;
}

void putVert(int x, int y)
{
	field[x] ^= 3 << y;
	field[x + 1] ^= 3 << y;
	field[x + 2] ^= 3 << y;
}

void rec(int x, int y)
{
//	cerr << x << " " << y << " " << cnt << endl;
	if (x == n)
	{
		ans = max(ans, cnt);
		return;
	}
	if (canHor(x, y))
	{
		putHor(x, y);
		++cnt;
		if (y == m - 3)
			rec(x + 1, 1);
		else
			rec(x, y + 1);
		--cnt;
		putHor(x, y);
	}
	if (canVert(x, y))
	{
		putVert(x, y);
		++cnt;
		if (y == m - 3)
			rec(x + 1, 1);
		else
			rec(x, y + 1);
		--cnt;
		putVert(x, y);
	}
	if (y == m - 3) rec(x + 1, 1);
	else rec(x, y + 1);
}

int main()
{
	#ifdef LOCAL
	assert(freopen(NAME ".in", "r", stdin));
	#endif // LOCAL
	int t;
	scanf("%d", &t);
	while (t --> 0)
	{
		scanf("%d%d", &n, &m);
		for (int i = 0; i < n; ++i)
			field[i] = 0;
		int k;
		scanf("%d", &k);
		for (int i = 0; i < k; ++i)
		{
			int a, b, w, h;
			scanf("%d%d%d%d", &a, &b, &w, &h);
			for (int x = a; x < a + w; ++x)
				for (int y = b; y < b + h; ++y)
					field[x] |= 1 << y;
		}
		ans = 0;
		rec(1, 1);
		printf("%d\n", ans);
	}
	#ifdef LOCAL
	cerr << "Time: " << double(clock()) / CLOCKS_PER_SEC << "\n";
	#endif // LOCAL
	return 0;
}
