#include <cstdio>
#include <iostream>
#include <string>
#include <vector>
#include <algorithm>
#include <cmath>
#include <cassert>
#include <memory.h>
#include <queue>
#include <deque>
#include <stack>
#include <list>
#include <map>
#include <set>
#include <functional>
#include <cstring>
#include <ctime>

using namespace std;

#define all(a) a.begin(), a.end()
#define mp make_pair

typedef long long li;
typedef long double ld;
typedef pair<int, int> pi;
typedef vector<int> vi;

#define FILENAME ""

void solve();
int main() {
#ifdef YA
	string s = FILENAME;
	//assert(!s.empty());
	clock_t start = clock();
	freopen("input.txt", "r", stdin);
	//freopen("output.txt", "w", stdout);
#else
	//freopen(FILENAME ".in", "r", stdin);
	//freopen(FILENAME ".out", "w", stdout);
	//freopen("input.txt", "r", stdin);
	//freopen("output.txt", "w", stdout);
#endif
	cout.sync_with_stdio(0);
	cin.tie(0);
	cout.precision(15);
	cout << fixed;

	int t = 1;
	cin >> t;
	while(t--) {
		solve();
	}
#ifdef YA
	cout << "\n\n" << (clock() - start) / 1.0 / CLOCKS_PER_SEC << "\n\n";
#endif
	return 0;
}


//#define int l

int n, m;

typedef vector <vi> vvi;

bool good(pair <int, int> a) {
	return a.first >= 0 && a.second >= 0 && a.first < n && a.second < m;
}

bool tryy(int x, int y, int w, int h, vvi& t) {
	for (int i = -1; i <= w; ++i) {
		for (int j = -1; j <= h; ++j) {
			pair <int, int> pos = mp(i + x, j + y);
			if (!good(pos)  || t[pos.first][pos.second] == 1) {
				return false;
			}
		}
	}
	return true;
}

void change(int x, int y, int v, int w, int h, vvi& t) {
	for (int i = 0; i < w; ++i) {
		for (int j = 0; j < h; ++j) {
			t[i + x][j + y] = v;
		}
	}
}

int go(vvi t) {
	int cnt = 0;

	int ans = 0;

	cnt = 0;
	for (int i = 1; i < n - 1; ++i) {
		for (int j = 1; j < m - 1; ++j) {
			if (tryy(i, j, 2, 3, t)) {
				++cnt;

				change(i, j, 1, 2, 3, t);

				ans = max(ans, 1 + go(t));

				change(i, j, 0, 2, 3, t);

				break;
			}
		}
		if (cnt == 3) {
			break;
		}
	}

	cnt = 0;
	for (int i = 1; i < n - 1; ++i) {
		for (int j = 1; j < m - 1; ++j) {
			if (tryy(i, j, 3, 2, t)) {
				++cnt;

				change(i, j, 1, 3, 2, t);

				ans = max(ans, 1 + go(t));

				change(i, j, 0, 3, 2, t);

				break;
			}
		}
		if (cnt == 4) {
			break;
		}
	}

	return ans;
}


void solve() {

	vector < vector <int> > init;

	int q;
	int ans = 0;
	cin >> n >> m >> q;
	init.assign(n, vector <int> (m, 0));
	for (int i = 0; i < q; ++i) {
		int x, y, w, h;
		cin >> x >> y >> w >> h;
		for (int x1 = 0; x1 < w; ++x1) {
			for (int y1 = 0; y1 < h; ++y1) {
				init[x + x1][y + y1] = 1;
			}
		}
	}

	cout << go(init) << endl;
}