#include <iostream>
#include <algorithm>
#include <vector>

using namespace std;

const int inf = 1e7;

int x[20000], y[20000];
int q[20000], d[20000];



vector<pair<int, int> > vec[20000];

int bfs(int num, int s,int f)
{
	
	int l = 0, r = 1;
	q[0] = s;
	d[s] = 0;
	while (l < r)
	{
		int v = q[l++];
		//cout << v << endl;
		for(int i = 0; i < vec[v].size(); i++)
		{
			if (vec[v][i].second == num)
				continue;
			int u = vec[v][i].first;
			if (d[u] > d[v] + 1) {
				d[u] = d[v] + 1;
				q[r++] = u;
			}
		}
	}

	return d[f];
	
}

int main()
{
	int t;
	cin >> t;
	for(int qwe = 0; qwe < t; qwe++)
	{
		int n, m;
		cin >> n >> m;
		for(int i = 0; i < n; i++)
			vec[i].clear();
		for(int i = 0; i < m; i++)
		{
			cin >> x[i] >> y[i];
			x[i]--, y[i]--;
			vec[x[i]].push_back(make_pair(y[i], i));
			vec[y[i]].push_back(make_pair(x[i], i));
		}
		int ans = n;
		for(int i = 0; i < m; i++)
		{
			for(int j = 0; j < n; j++)
			{
				d[j] = inf;
			}
			ans = min(ans, bfs(i, x[i], y[i]) + 1);
		}
		cout << ans << endl;
	}
	return 0;
}