#include <iostream>
#include <cstdio>
#include <set>
#include <map>
#include <queue>
#include <vector>
#include <fstream>
#include <sstream>
#include <algorithm>
#include <cassert>
#include <ctime>
#include <cmath>
#include <string>
#include <memory.h>

#define forn(i, n) for(int i = 0; i < (int)(n); ++i)
#define fore(i, a, b) for(int i = (int)(a); i <= (int)(b); ++i) 
#define for1(i, n) for(int i = 1; i <= (int)(n); ++i)
#define ford(i, n) for(int i = (int)(n) - 1; i >= 0; --i)
#define all(x) (x).begin(), (x).end()
#define mp make_pair
#define pb push_back
#define fi first
#define se second

using namespace std;

typedef long double ld;
typedef long long i64;
typedef vector<int> vi;
typedef vector<i64> vi64;
typedef pair<int, int> pii;
typedef unsigned int u32;
typedef vector<pii> vpi;

const int N  = (1 << 17);
int tree[N];

int sum(int x)
{
	int r = 0;
	for (; x >= 0; x = (x & (x + 1)) - 1)
		r += tree[x];
	return r;
}

void inc(int x, int i)
{
	for (; x < N; x = (x | (x + 1)))
		tree[x] += i;
}

void solve()
{
	int n;
	scanf("%d", &n);
	vi a(n);
	forn (i, n)
	{
		scanf("%d", &a[i]);
	}
	forn (i, N) tree[i] = 0;
	int r = 0;
	vi ans;
	ford (i, n)
	{
		ans.pb(sum(a[i]));
		inc(a[i], 1);
	}
	reverse(all(ans));
	for (int x: ans) printf("%d ", x);
	puts("");
}
int main() {
	cin.sync_with_stdio();
	cin.tie(0);
	cout.precision(12);
	cout << fixed;
	cerr.precision(12);
	cerr << fixed;
#ifdef HOME
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif
	int T;
	scanf("%d", &T);
	forn (i, T) solve();
	return 0;
}
