#include <iostream>
#include <cstdio>
#include <set>
#include <map>
#include <queue>
#include <vector>
#include <fstream>
#include <sstream>
#include <algorithm>
#include <cassert>
#include <ctime>
#include <cmath>
#include <string>
#include <memory.h>
#include <unordered_map>

#define forn(i, n) for(int i = 0; i < (int)(n); ++i)
#define fore(i, a, b) for(int i = (int)(a); i <= (int)(b); ++i) 
#define for1(i, n) for(int i = 1; i <= (int)(n); ++i)
#define ford(i, n) for(int i = (int)(n) - 1; i >= 0; --i)
#define all(x) (x).begin(), (x).end()
#define mp make_pair
#define pb push_back
#define fi first
#define se second

using namespace std;

typedef long double ld;
typedef long long i64;
typedef vector<int> vi;
typedef vector<i64> vi64;
typedef pair<int, int> pii;
typedef unsigned int u32;
typedef vector<pii> vpi;

const int N = 1e5 + 1, K = 100;

int a[K], b[K];
int d[N + K];
bool ex[N+K];

const int MOD = 1e9;
inline void add(int &x, int y)
{
	x += y;
	if (x >= MOD) x -= MOD;
}

void solve() {
	int n, m;
	scanf("%d%d", &n, &m);
	int k;
	scanf("%d", &k);
	forn (i, k)
		scanf("%d", &a[i]);
	sort(a, a + k);
	k = unique(a, a + k) - a;
	int s;
	scanf("%d", &s);
	forn (i, s)
		scanf("%d", &b[i]);
	sort(b, b + s);
	s = unique(b, b + s) - b;
	fore(i, n, m) d[i] = 0;
	d[n] = 1;
	int ans = 0;
	fore(i,n,m/2)
		if (d[i])
		{
			int mx = m / i;
			bool ok = (m - i * mx == 0);
			forn (j, k)
				add(d[i + a[j]], d[i]);
			forn (j, s)
				if (b[j] > mx)
					break;
				else {
					add(d[i * b[j]], d[i]);
					if (b[j] == mx && ok)
						add(ans, d[i]);
				}
		}
	cout << ans << "\n";
}

int main() {
	
	cin.sync_with_stdio();
	cin.tie(0);
	cout.precision(12);
	cout << fixed;
	cerr.precision(12);
	cerr << fixed;
#ifdef HOME
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif

	int T;
	scanf("%d", &T);
	forn(t, T) {
		solve();
	}
	return 0;
}
