#include <iostream>
#include <iomanip>
#include <string>
#include <cmath>
#include <vector>
#include <algorithm>
#include <ctime>
#include <unordered_map>

using namespace std;

typedef long long ll;

inline int tonum(const string& a){
	int ans = 0;
	for (int i = 0; i < a.size(); ++i){
		ans <<= 1;
		if (a[i] == '1') ans |= 1;
	}
	return ans;
}
inline int mylen(int num){
	if (num == 0) return 1;
	int ans = 0;
	while (num > 0){
		++ans;
		num >>= 1;
	}
	return ans;
}

inline void prnt(int cnt, char c){
	for (int i = 0; i < cnt; ++i) cout << c;
}
inline vector<int> tos(int num){
	vector<int> ans;
	if (num == 0){
		ans.push_back(0);
	} else {
		while (num) {
			ans.push_back(num & 1);
			num >>= 1;
		}
	}
	reverse(ans.begin(), ans.end());
	return ans;
}

inline void solve(){
	string a, b;
	cin >> a >> b;
	int na = tonum(a);
	int nb = tonum(b);
	int nc = na * nb;
	int len = mylen(nc);
	len = max(len, (int)max(a.size(), b.size()));
	prnt(len - a.size(), ' '); cout << a << endl;
	prnt(len - b.size(), ' '); cout << b << endl;
	prnt(len - max(a.size(), b.size()), ' ');
	prnt(max(a.size(), b.size()), '-');
	cout << endl;
	int rsp = 0;
	int lsp = len - a.size();
	for (int i = b.size() - 1; i >= 0; --i){
		prnt(lsp, ' ');
		if (b[i] == '1') cout << a;
		else prnt(a.size(), '0');
		prnt(rsp, ' ');
		--lsp; ++rsp;
		cout << endl;
	}
	prnt(len, '-');
	cout << endl;
	vector<int> x = tos(nc);
	prnt(len - x.size(), ' ');
	for (int i = 0; i < x.size(); ++i)
		cout << x[i];
	cout << endl;
}

int main(){
	ios_base::sync_with_stdio(false);
	int ttt;
	cin >> ttt;
	for (int i = 0; i < ttt; ++i){
		cout << "Test " << i + 1 << endl;
		solve();
		cout << endl;
	}
	return 0;
}