#include <iostream>
#include <iomanip>
#include <string>
#include <cmath>
#include <vector>
#include <algorithm>
#include <ctime>
#include <unordered_map>
#include <queue>
#include <stack>
using namespace std;

typedef long long ll;

const int N = 50000;
int dp[N];
const int inf = 1e9;

inline bool havenot0(const vector<int>& x){
	for (int i = 0; i < x.size(); ++i)
		if (x[i] != 0)
			return true;
	return false;
}

inline ll cnt(vector<int>& x){
	ll ans = 0;
	while (havenot0(x)){
		for (int i = 0; i < x.size(); ++i){
			if (x[i] % 10 != 0){
				++ans;
				x[i] -= x[i] % 10;
			}
		}
		if (havenot0(x)){
			++ans;
			for(int i = 0; i < x.size(); ++i)
				x[i] /= 10;
		}
	}
	return ans;
}

inline void solve(){
	int n; cin >> n;
	int ans = 0;
	vector<int> x(n);
	for (int i = 0; i < n; ++i){
		cin >> x[i];
	}
	ans = cnt(x);
	cout << ans << endl;
}

int main(){
	ios_base::sync_with_stdio(false);
	fill(dp, dp + N, inf);
	for (int i = 0; i < 10; ++i) dp[i] = 1;
	dp[0] = 0;
	for (int i = 10; i < N; ++i) {
		for (int j = 1; j < 10; ++j)
			dp[i] = min(dp[i - j] + 1, dp[i]);
		if (i % 10 == 0)
			dp[i] = min(dp[i], dp[i / 10] + 1);
	}

	int ttt;
	cin >> ttt;
	for (int i = 0; i < ttt; ++i){
		solve();
	}
	return 0;
}