#include <cstdio>
#include <cstdlib>
#include <cmath>
#include <cassert>
#include <ctime>
#include <cstring>
#include <algorithm>
#include <iostream>
#include <set>
#include <map>
#include <vector>
#include <queue>
#include <deque>
using namespace std;
#define pb push_back
#define mp make_pair
#define sc second
#define fs first
#define int64 long long
#define ldb long double
#define sz(a) ((int) (a).size())
#define eprintf(...) fprintf(stderr, __VA_ARGS__)
const int N = (int) 1e5 + 10;
int a[N], sum[4 * N], n, t, ans[N];

int get(int t, int l, int r, int x, int y) {
	if ((y <= l) || (r <= x)) return 0;
	if ((x <= l) && (r <= y)) return sum[t];
	int m = (l + r) / 2;
	return get(t * 2 + 1, l, m, x, y) + get(t * 2 + 2, m, r, x, y);
}

void update(int t, int l, int r, int x) {
	sum[t]++;
	if (l != r - 1) {
		int m = (l + r) / 2;
		if (x < m) update(t * 2 + 1, l, m, x);
		else update(t * 2 + 2, m, r, x);
	}
}

void init(int t, int l, int r) {
	sum[t] = 0;
	if (l + 1 != r) {
		int m = (l + r) / 2;
		init(t * 2 + 1, l, m);
		init(t * 2 + 2, m, r);
	}
}

int main() {
	//assert(freopen("input.txt", "r", stdin));
	//assert(freopen("output.txt", "w", stdout));
	scanf("%d", &t);
	for (int it = 0; it < t; ++it) {
		scanf("%d", &n);
		init(0, 0, n);
		for (int i = 0; i < n; ++i)
			scanf("%d", &a[i]), --a[i];
		for (int i = n - 1; i >= 0; --i) {
			ans[i] = get(0, 0, n, 0, a[i]);
			update(0, 0, n, a[i]);
		}
		for (int i = 0; i < n; ++i)
			printf("%d%c", ans[i], " \n"[i == n - 1]);
	}
	return 0;
}