#include <iostream> 
#include <cstdio> 
#include <map> 
#include <set> 
#include <algorithm> 
#include <cstdlib> 
#include <cstring>
#include <cassert>
#include <utility>
#include <vector>
#include <string>
#include <queue>
#include <fstream> 
#include <iomanip> 
#include <sstream> 
#include <cmath> 
#include <ctime> 
#include <cctype> 
#include <deque> 

#define pb push_back
#define mp make_pair

using namespace std;

typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;
typedef pair< int, int > pii1;
typedef vector< int > vi;
typedef pair<pii1, pii1> pii;

template <class T> inline void updMax(T &x, const T &other) { if (x < other) x = other; }
template <class T> inline void updMin(T &x, const T &other) { if (other < x) x = other; }
template <class T> inline T sqr(const T &x) { return x * x; } 

int n, m; 
vector<pii> mas; 
vector<pii> bad;
map < vector<pii>, bool > used; 

bool inline cross(int x, int y, int xx, int yy, int xn ,int yn, int xxn, int yyn) {
	int maxl = max(x, xn); 
	int mayl = max(y, yn); 

	int mixr = min(xx, xxn);
	int miyr = min(yy, yyn);
	return mixr >= maxl && miyr >= mayl; 
}

bool can(int x, int y, int xx, int yy) {
	if (xx == n - 1 || yy == m - 1) return false;
	for (int i = 0; i < mas.size(); i++) {
		int xn = mas[i].first.first; 
		int yn = mas[i].first.second; 
		int xxn = mas[i].second.first; 
		int yyn = mas[i].second.second; 

		if (cross(x - 1, y - 1, xx + 1, yy + 1, xn, yn, xxn, yyn)) return false;
	}
	for (int i = 0; i < bad.size(); i++) {
		int xn = bad[i].first.first; 
		int yn = bad[i].first.second; 
		int xxn = bad[i].second.first; 
		int yyn = bad[i].second.second; 

		if (cross(x - 1, y - 1, xx + 1, yy + 1, xn, yn, xxn, yyn)) return false;
	}
	return true;
}

int ans = 1000; 

void gen() {
	vector< pii > mas2 = mas; 
	sort(mas2.begin(), mas2.end()); 
	int cur = mas.size();
	if (cur > ans) ans = cur; 
	if (used[mas2]) return;
	used[mas2] = 1; 

	for (int i = 1; i < n - 2; i++) {
		for (int j = 1; j < m - 2; j++) {
			if (can(i, j, i + 1, j + 2)) {
				mas.pb(mp(mp(i, j), mp(i + 1, j + 2))); 
				gen(); 
				mas.pop_back(); 
			}
			if (can(i, j, i + 2, j + 1)) {
				mas.pb(mp(mp(i, j), mp(i + 2, j + 1))); 
				gen(); 
				mas.pop_back(); 
			}
		}
	}
}

int main()
{
	//freopen("input.txt", "r", stdin); freopen("output.txt", "w", stdout);
	//freopen(".in", "r", stdin); freopen(".out", "w", stdout);
	
	//ios::sync_with_stdio(false); 

	int t; 
	cin >> t; 
	for (int i = 0; i < t; i ++) {
		cin >> n >> m; 
		int b; 
		cin >> b; 
		bad.clear(); 
		for (int j = 0; j < b; j++) {
			int x, y, w, h; 
			cin >> x >> y >> w >> h; 
			bad.pb(mp(mp(x, y), mp(x + w - 1, y + h - 1))); 
		}
		ans = 0; 
		used.clear(); 
		gen(); 
		cout << ans << endl; 
	}
	
	return 0;
}