#include <iostream>
#include <cstdio>
#include <cstdlib>
#include <cmath>
#include <ctime>
#include <cstring>
#include <cassert>
#include <algorithm>
#include <vector>
#include <set>
#include <map>
#include <bitset>
#include <stack>
#include <queue>
#include <deque>
#include <complex>

using namespace std;

#define pb push_back
#define mp make_pair
#define sz(s) int((s).size())
#define len(s) int((s).size())
#define all(s) (s).begin(), (s).end()
#ifdef _WIN32
#define LLD "%I64d"
#else
#define LLD "%lld"
#endif
#ifdef LOCAL42
#define eprintf(...) fprintf(stderr, __VA_ARGS__)
#else
#define eprintf(...) 42
#endif
#define y0 yy0
#define y1 yy1
#define next _next
#define prev _prev
#define rank _rank
#define link _link
#define hash _hash
#define fs first
#define sc second

typedef long long ll;
typedef long long llong;
typedef long long int64;
typedef unsigned int uint;
typedef long double ld;
typedef unsigned long long ull;
typedef unsigned long long ullong;
typedef unsigned long long lint;
typedef pair<int, int> pii;
typedef vector<int> vi;

const int inf = int(1e9);
const double eps = 1e-9;
const double pi = 4 * atan(double(1));
const int N = int(1e5) + 100;
const int MOD = int(1e9);

int a[N], b[N];
int d[N][2];

inline void norm(int &a) {
	while (a >= MOD) {
		a -= MOD;
	}
}

inline void solve() {
	int n, m;
	scanf("%d %d", &n, &m);
	int k;
	scanf("%d", &k);
	for (int i = 0; i < k; ++i) {
		scanf("%d", &a[i]);
	}
	sort(a, a + k);
	k = unique(a, a + k) - a;
	int s;
	scanf("%d", &s);
	for (int i = 0; i < s; ++i) {
		scanf("%d", &b[i]);
	}
	sort(b, b + s);
	s = unique(b, b + s) - b;
	for (int i = n; i <= m; ++i) {
		for (int j = 0; j < 2; ++j) {
			d[i][j] = 0;
		}
	}
	d[n][0] = 1;
	for (int i = n; i < m; ++i) {
		for (int j = 0; j < 2; ++j) {
			if (d[i][j] == 0) {
				continue;
			}
			for (int z = 0; z < k && i + a[z] <= m; ++z) {
				d[i + a[z]][0] += d[i][j];
				norm(d[i + a[z]][0]);
			}
			for (int z = 0; z < s && i * b[z] <= m; ++z) {
				d[i * b[z]][1] += d[i][j];
				norm(d[i * b[z]][1]);
			}
		}
	}
	printf("%d\n", d[m][1]);
}

int main() {
#ifdef LOCAL42
#define TASK "E"
	freopen(TASK ".in", "r", stdin);
	freopen(TASK ".out", "w", stdout);
#else

#endif
	int t;
	scanf("%d", &t);
	for (int i = 0; i < t; ++i) {
		solve();
	}
	return 0;
}
