#include <cstdio>
#include <iostream>
#include <vector>
#include <algorithm>
#include <cstring>
#include <string>
#include <cmath>
#include <map>
#include <set>
#include <climits>
#include <cassert>
#include <cctype>
#include <queue>
#include <ctime>
using namespace std;

typedef long long ll;
typedef double dbl;
typedef long double ld;

#define mp make_pair
#define pb push_back
#define sz(x) (int)x.size()
#define all(x) x.begin(),x.end()
#define X first
#define Y second

const ll maxn = 2000*100 + 10;
const dbl eps = 1e-9;
const int mod = 2017;

int main() {
#ifdef _MBCS
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif
	int t;
	scanf("%d", &t);
	for (int i = 0; i < t; i++) {
		int n, k;
		scanf("%d%d", &n, &k);

		vector<int> v(n);
		for (int j = 0; j < n; j++)
			scanf("%d", &v[j]);

		ll l = -1, r = (ll)1e18 + 1;
		while (r - l > 1) {
			ll mid = (r + l) / 2;

			ll ans = 0;
			bool flag = false;
			for (int j = 0; j < n; j++) {
				ans += mid / v[j];
				if (ans >= k) {
					r = mid;
					flag = true;
					break;
				}
			}

			if (flag) continue;

			if (ans < k) l = mid;
			else r = mid;
		}

		printf("%lld\n", r);
	}
	

	/*int t;
	scanf("%d", &t);
	for (int i = 0; i < t; i++) {
		int n;
		scanf("%d", &n);
		
	}*/
	

	return 0;
}