#define _USE_MATH_DEFINES

#include <cstdio>
#include <iostream>
#include <iomanip>
#include <vector>
#include <algorithm>
#include <string>
#include <cstring>
#include <map>
#include <set>
#include <queue>
#include <cassert>
#include <stack>
#include <cstdlib>
#include <bitset>
#include <cmath>

#define forn(i,n) for (int i = 0; i < int(n); ++i)
#define pb push_back
#define all(a) a.begin(),a.end()
#define sz(a) int(a.size())
#define mp make_pair

using namespace std;

typedef long long li;
typedef long double ld;

typedef pair<int,int> pt;
#define ft first
#define sc second

const int INF = int(1e9);
const li INF64 = li(1e18);
const ld EPS = 1e-9;

//#define TASK_NAME ""

int n, k;

bool read() {
	if (scanf("%d %d", &n, &k) != 2)
		return false;
	return true;
}

const int MOD = 2017;

int binpow(int a, int b, int m) {
	a %= m;

	int res = 1, c = a;

	for (int i = 0; (1 << i) <= b; ++i) {
		if (b & (1 << i))
			res = (res * c) % m;
		c = (c * c) % m;
	}

	return res;
}

void solve() {
	int res = 0;
	int C = 1;
	forn(c, k) {

		if (c) {
			C = C * (k - c + 1) * binpow(c, MOD - 2, MOD);
			C %= MOD;
		}

		res += ((c & 1) ? -1 : +1) * binpow(k - c, n, MOD) * C;
		res = (res % MOD + MOD) % MOD;
	}

	res *= binpow(k, MOD - 2, MOD);
	res %= MOD;

	cout << res << endl;
}

int main() {
#ifdef TASK_NAME
	freopen(TASK_NAME ".in", "r", stdin);
	freopen(TASK_NAME ".out", "w", stdout);
#endif

#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	//freopen("output.txt", "w", stdout);
#endif

	int t;
	scanf("%d", &t);

	while (read())
		solve();

	return 0;
}