#if 1
#include <cstdio>
#include <cstring>
#include <vector>
using namespace std;
const int maxn = 1e5, maxv = 1e6 + 1;
int arr[maxn], ans[maxn];

struct ftype
{
	vector<int> arr;
	ftype(int n) {arr.resize(n);}
	void inc(int p)
	{
		for (int i = p; i < arr.size(); i = (i + 1) | i)
		{
			arr[i]++;
		}
	}
	int getsum(int r)
	{
		int result = 0;
		for (int i = r; i >= 0; i = ((i + 1) & i) - 1)
		{
			result += arr[i];
		}
		return result;
	}
};

int main()
{
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
#endif
	int T; scanf("%d", &T);
	for (int t = 1; t <= T; ++t)
	{
		int n; scanf("%d", &n);
		ftype F(maxv);
		for (int i = 0; i < n; ++i) scanf("%d", &arr[i]);
		for (int i = n - 1; i >= 0; --i) 
		{
			ans[i] = F.getsum(arr[i]);
			F.inc(arr[i]);
		}
		for (int i = 0; i < n; ++i) 
		{
			if(i) printf(" ");
			printf("%d", ans[i]);
		}
		printf("\n");
	}
	return 0;
}
#endif